#include <amdis/AMDiS.hpp>
#include <amdis/common/TypeTraits.hpp>

using namespace AMDiS;

template <std::size_t i>
struct A {};

template <class T>
struct B {};

template <class T, std::size_t i>
struct C {};


struct D {};


int main(int argc, char** argv)
{
  Environment env(argc, argv);

  static_assert(is_template<A>(), "");
  static_assert(is_template<B>(), "");
  static_assert(is_template<C>(), "");

  static_assert(not is_template<std::size_t>(), "");
  static_assert(not is_template<D>(), "");

  return 0;
}
